Dim pNames() AS string
Dim sNameLT() AS string
Dim secGrouping() AS string
Dim sNameUT() AS string

Begin Dialog NewDialog 25,-35,366,284,"Grouping Join", .NewDialog
  OKButton 45,214,76,40, "OK", .OKButton1
  CancelButton 155,213,85,43, "Cancel", .CancelButton1
  TextBox 30,28,145,10, .primarytext
  PushButton 10,28,15,10, "...", .PushButton2
  Text 10,14,55,10, "Select Primary File:", .Text2
  Text 201,13,122,9, "Primary field to compare against secondary:", .Text3
  DropListBox 196,28,145,10, pNames(), .fieldp
  TextBox 32,81,145,10, .secondarytext
  PushButton 12,81,15,10, "...", .PushButton2
  Text 11,67,120,8, "Select secondary file (usually a Master file):", .Text2
  Text 201,68,136,8, "Lower Threshold:", .Text3
  DropListBox 199,80,145,11, sNameLT(), .fieldsecLT
  Text 11,120,152,10, "Secondary field to include in output (i.e. GRPOUPING):", .Text4
  DropListBox 13,138,145,10, secGrouping(), .GroupingID
  TextBox 241,151,63,14, .completiontext
  Text 223,134,115,12, "Estimated time to complete join:", .Text1
  DropListBox 200,105,145,11, sNameUT(), .fieldsecUT
  Text 201,95,136,9, "Upper Threshold:", .Text6
  CheckBox 21,178,237,15, "     Check to use last match occurence.  Otherwise first match occurence will be used.", .LastOcc
End Dialog

'********************************************************************************************************************************************
'* Script:	Grouping - Between Join v1.iss
'* Author:  Scott Winkel - 587-475-3730
'*	Contact me for errors or recommendations
'* Date:	  October 18, 2016
' Purpose :	 This script will take two files and join one field from the secodary database (i.e. GROUPING_FIELD)
'	   It compares one field in the primary database against two fields in the secondary database to see if it is between the lower and upper threshold.
'* This script is presented without any warranty or guarantee.  Users are encouraged to validate the effectiveness and reliability on their own.
'********************************************************************************************************************************************
'Option Explicit

Dim otherSfield As String
Dim rs As Object
Dim db As Object
Dim Prec As String
Dim Srec As String
Dim Srec1 As String
Dim Srec2 As String
Dim FileExtension As String
Dim FilePath As String
Dim FileNameAndFolder As String
Dim JustFileName As String
Dim JustFileNameNoExt As String

Sub Main()
	
	Dim a, b, c, d, e, i, p As Long
	Dim pLimit As Long
	Dim sLimit As Long
	Dim button As Integer
	Dim sGroupingChoice As Integer
	Dim Dlg1 As NewDialog
	Dim fields As Integer
	Dim fields1 As Integer
	Dim newfield As String
	Dim newFieldOther As String
	Dim otherSlength As Integer
	Dim PrimaryDBname As String
	Dim PrimaryDBnameJoin As String
	Dim PrimaryDBnameWithGrouping As String
	Dim dbName As String
	Dim pChoice As Integer
	Dim sChoiceLT As Integer
	Dim sChoiceUT As Integer
	Dim secLength() As Integer
	Dim SecondaryDBname As String
	Dim secondary As Object
	Dim slen As Integer
	Dim sLength() As String
	Dim rec As Object
	Dim percentComplete As Object
	Dim table As Object
	Dim table1 As Object
	Dim field As Object
	Dim filebar As Object
	Dim secType() As String
	Dim TimeVar As Variant
	Dim StartTime As Variant
	Dim EndTime As Variant
	Dim pType() As String
	Dim sTypeLT() As String
	Dim sTypeUT() As String
	Dim LastOcc As Integer
	
	TimeVar = 0.00007
	
	working_directory = Client.WorkingDirectory()
	
	
	Do
FileSelect:
		button = Dialog(Dlg1)
		
		Select Case button
			
			Case 1
			Set filebar = CreateObject("ideaex.fileexplorer")
			filebar.displaydialog
			PrimaryDBname = filebar.SelectedFile
			Dlg1.primarytext = PrimaryDBname
			
			If PrimaryDBname <> "" Then
				
				Set db = Client.OpenDatabase(PrimaryDBname)
				PrecordCount = db.Count
				Set table = db.TableDef
				fields = table.Count
				
				ReDim pNames(fields)
				ReDim pType(fields)
				
				a = 1
				For i = 1 To fields
					
					Set field = table.GetFieldat(i)
					
					pNames(a) = field.Name
					pType(a) = field.Type
					a = a + 1
					
				Next i
				
			End If
			
			Case 2
			Set filebar = CreateObject("ideaex.fileexplorer")
			filebar.displaydialog
			SecondaryDBname = filebar.SelectedFile
			Dlg1.secondarytext = SecondaryDBname
			
			If SecondaryDBname <> "" Then
				
				Set secondary = Client.OpenDatabase(SecondaryDBname)
				SrecordCount = secondary.Count
				Set table1 = secondary.TableDef
				fields1 = table1.Count
				
				ReDim sNameLT(fields1)
				ReDim sNameUT(fields1)
				ReDim sLength(fields1)
				ReDim sTypeLT(fields1)
				ReDim sTypeUT(fields1)
				
				ReDim secGrouping(fields1)
				ReDim secLength(fields1)
				ReDim secType(fields1)
				
				b = 1
				For i = 1 To fields1
					
					Set field = table1.GetFieldat(i)
					
					sNameLT(b) = field.Name
					sNameUT(b) = field.Name
					sTypeLT(b) = field.Type
					sTypeUT(b) = field.Type
					
					b = b + 1
					
					secGrouping(i) = field.Name
					secType(i) = field.Type
					secLength(i) = field.Length
					
				Next i
				
				
			End If
			
			If Dlg1.primarytext <> "" And Dlg1.secondarytext <> "" Then
				If (PrecordCount * SrecordCount) * TimeVar > 3600 Then
					Dlg1.completiontext = Round(((PrecordCount * SrecordCount) * TimeVar) / 60 / 60, 2) & " hours"
					ElseIf (PrecordCount * SrecordCount) * TimeVar > 60 Then
					Dlg1.completiontext = Round(((PrecordCount * SrecordCount) * TimeVar) / 60, 0) & " minutes"
				Else
					Dlg1.completiontext = Round((PrecordCount * SrecordCount) * TimeVar, 0) & " seconds"
				End If
			Else
				Dlg1.completiontext = ""
				
			End If
			
		End Select
		
		If button = 0 Then Exit Sub
		
		pChoice = Dlg1.fieldp + 1
		sChoiceLT = Dlg1.fieldsecLT + 1
		sChoiceUT = Dlg1.fieldsecUT + 1
		sGroupingChoice = Dlg1.GroupingID + 1
		LastOcc = Dlg1.LastOcc
		
		If sChoiceLT <> 0 Then
			
			If sTypeLT(sChoiceLT) = 0 Or sTypeLT(sChoiceLT) = 3 Then
				TypeLT = "Character"
				ElseIf sTypeLT(sChoiceLT) = 1 Or sTypeLT(sChoiceLT) = 4 Then
				TypeLT = "Numeric"
				ElseIf sTypeLT(sChoiceLT) = 2 Or sTypeLT(sChoiceLT) = 5 Then
				TypeLT = "Date"
			Else
				TypeLT = "zz"
				
			End If
			
		End If
		
		If sChoiceUT <> 0 Then
			
			If sTypeUT(sChoiceUT) = 0 Or sTypeUT(sChoiceUT) = 3 Then
				TypeUT = "Character"
				ElseIf sTypeUT(sChoiceUT) = 1 Or sTypeUT(sChoiceUT) = 4 Then
				TypeUT = "Numeric"
				ElseIf sTypeUT(sChoiceUT) = 2 Or sTypeUT(sChoiceUT) = 5 Then
				TypeUT = "Date"
			Else
				TypeUT = "yy"
				
			End If
			
		End If
		
		If pChoice <> 0 Then
			
			If pType(pChoice) = 0 Or pType(pChoice) = 3 Then
				TypeP = "Character"
				ElseIf pType(pChoice) = 1 Or pType(pChoice) = 4 Then
				TypeP = "Numeric"
				ElseIf pType(pChoice) = 2 Or pType(pChoice) = 5 Then
				TypeP = "Date"
			Else
				TypeP = "xx"
				
			End If
			
		End If
		
		
		If PrimaryDBname = SecondaryDBname And button < 1 Then
			MsgBox "Primary and Secondary Files cannot be the same!", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If PrimaryDBname = "" And button < 1 Then
			MsgBox "Please select a primary file!", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If SecondaryDBname = "" And button < 1 Then
			MsgBox "Please select a secondary file!", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If pChoice = 0 And button < 1 Then
			MsgBox "Please select a primary field to compare!", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If sChoiceLT = 0 And button < 1 Then
			MsgBox "Please select a lower threshold!", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If sChoiceUT = 0 And button < 1 Then
			MsgBox "Please select an upper threshold!", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If sGroupingChoice = 0 And button < 1 Then
			MsgBox "Please select one field to include to join (i.e. Grouping Description)", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If (sGroupingChoice = sChoiceLT) And sGroupingChoice > 0 And button < 1 Then
			MsgBox "Grouping Field Description cannot be the same as the lower threshold.", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If (sGroupingChoice = sChoiceUT) And sGroupingChoice > 0 And button < 1 Then
			MsgBox "Grouping Field Description cannot be the same as the upper threshold.", MB_ICONEXCLAMATION, "Error"
			GoTo FileSelect:
		End If
		
		If sChoiceLT <> 0 And sChoiceUT <> 0 And sGroupingChoice <> 0 Then
			If TypeLT <> TypeUT Or TypeLT <> TypeP And button < 1 Then
				MsgBox "The primary field and the lower and upper threshold must all be the same field type." & Chr(13) & pNames(pChoice) & " is " & TypeP & Chr(13) & sNameLT(sChoiceLT) & " is " & TypeLT & Chr(13) & sNameUT(sChoiceUT) & " is " & TypeUT, MB_ICONEXCLAMATION, "Error"
				GoTo FileSelect:
			End If
		End If
		
	Loop Until button < 1 And PrimaryDBname <> "" And SecondaryDBname <> "" And pChoice > 0 And sChoiceLT > 0 And sGroupingChoice > 0
	
	newFieldOther = "S_" + secGrouping(sGroupingChoice)
	
	otherSfield = secGrouping(sGroupingChoice)
	otherStype = secType(sGroupingChoice)
	otherSlength = secLength(sGroupingChoice)
	
	Set db = Client.OpenDatabase(SecondaryDBname)
	Set table = db.TableDef
	Set field = table.GetField(otherSfield)
	If field.IsNumeric = True Then
		Set task = db.TableManagement
		Set field = table.newfield
		field.Name = otherSfield
		field.Type = WI_CHAR_FIELD
		field.Length = 8
		task.ReplaceField otherSfield, field
		task.PerformTask
		ElseIf field.IsDate = True Then
		Set task = db.TableManagement
		Set field = table.newfield
		field.Name = otherSfield
		field.Type = WI_CHAR_FIELD
		task.ReplaceField otherSfield, field
		task.PerformTask
	End If
	
	Set task = Nothing
	Set table = Nothing
	Set field = Nothing
	Set db = Nothing
	
	
	'-------------- Add First Field ------'
	
	PrimaryDBnameWithGrouping = ireplace(PrimaryDBname, ".IMD", "") & " with " & secGrouping(sGroupingChoice) & ".IMD"
	NamesAndPaths (PrimaryDBnameWithGrouping)
	PrimaryDBnameWithGrouping = JustFileName
	
	Set db = Client.OpenDatabase(PrimaryDBname)
	Set task = db.Extraction
	task.IncludeAllFields
	dbName = Client.UniqueFileName(PrimaryDBnameWithGrouping)
	task.AddExtraction dbName, "", ""
	task.PerformTask 1, db.Count
	Set task = Nothing
	Set db = Nothing
	Set db = Client.OpenDatabase(dbName)
	
	Set task = db.TableManagement
	Set table = db.TableDef
	Set field = table.newfield
	eqn = """"""
	field.Name = newFieldOther
	field.Description = ""
	field.Type = WI_EDIT_CHAR
	field.Equation = eqn
	field.Length = otherSlength
	task.AppendField field
	task.PerformTask
	Set task = Nothing
	Set field = Nothing
	Set table = Nothing
	
	
	StartTime = Timer
	Set db = Client.OpenDatabase(dbName)
	Set rs = db.Recordset
	
	pLimit = rs.Count
	
	Set percentComplete = CreateObject("CommonIdeaControls.StandaloneProgressCtl")
	percentComplete.Start "Percent Complete"
	
	c = 1
	
	' Loop from record 1 to end of database
	For c = 1 To pLimit
		
		'rs.Next
		rs.GetAt (c)
		Set rec = rs.ActiveRecord
		
		
		If TypeP = "Character" Then
			Prec = rec.GetCharValue(pNames(pChoice))
			ElseIf TypeP = "Numeric" Then
			Prec = rec.GetNumValue(pNames(pChoice))
			ElseIf TypeP = "Date" Then
			Prec = rec.GetDateValue(pNames(pChoice))
		End If
		
		Set db1 = Client.OpenDatabase(SecondaryDBname)
		
		Set rs = db1.Recordset
		
		sLimit = rs.Count
		
		' Loop from record 1 to end of database
		For d = 1 To sLimit
			
			'rs.Next
			rs.GetAt (d)
			Set rec = rs.ActiveRecord
			
			If TypeP = "Character" Then
				Srec = rec.GetCharValue(sNameLT(sChoiceLT))
				Srec1 = rec.GetCharValue(sNameUT(sChoiceUT))
				ElseIf TypeP = "Numeric" Then
				Srec = rec.GetNumValue(sNameLT(sChoiceLT))
				Srec1 = rec.GetNumValue(sNameUT(sChoiceUT))
				ElseIf TypeP = "Date" Then
				Srec = rec.GetDateValue(sNameLT(sChoiceLT))
				Srec1 = rec.GetDateValue(sNameUT(sChoiceUT))
			End If
			
			If Prec = Srec Or Prec = Srec1 Or (Prec >= Srec And Prec <= Srec1) Then
				
				Srec2 = rec.GetCharValue(secGrouping(sGroupingChoice))
				
				Set db = Client.OpenDatabase(dbName)
				
				Set rs = db.Recordset
				rs.GetAt (c)
				Set rec = rs.ActiveRecord
				
				rec.SetCharValue newFieldOther, Srec2
				
				rs.SaveRecord rec
				
				If LastOcc = 0 Then
					d = sLimit
				Else
					Set db1 = Client.OpenDatabase(SecondaryDBname)
					Set rs = db1.Recordset
				End If
				
			End If
			
		Next d
		
		Set db = Client.OpenDatabase(dbName)
		
		Set rs = db.Recordset
		
		If Int(c * (100 / pLimit)) > e Then
			e = Int(c * (100 / pLimit))
			percentComplete.Progress e
		End If
		
	Next c
	
	
EndPart:
	
	Set db = Client.OpenDatabase(dbName)
	Set table = db.TableDef
	table.Protect = True
	Set task = Nothing
	Set table = Nothing
	Set db = Nothing
	
	
	EndTime = Timer
	MsgBox "Join Complete!" & Chr(13) & "The elapsed time to complete join was: " & Round(EndTime - StartTime, 0) & " seconds." & Chr(13) & "	Or:  " & Chr(13) & Round((EndTime - StartTime) / 60, 2) & " minutes."
	
	
ExitScript:
	
	' Reset objects
	Set task = Nothing
	Set table = Nothing
	Set table1 = Nothing
	Set db = Nothing
	Set db1 = Nothing
	Set rs = Nothing
	Set rec = Nothing
	Set secondary = Nothing
	Set percentComplete = Nothing
	Set field = Nothing
	Set filebar = Nothing
	
	
	Client.CloseAll
	Client.RefreshFileExplorer
	
	Client.OpenDatabase (PrimaryDBname)
	Client.OpenDatabase (dbName)
	
	Exit Sub
	
	
	
	Set task = Nothing
	Set db = Nothing
	Set table = Nothing
	Set field = Nothing
	
End Sub

Function NamesAndPaths(ByVal dbstring As String) As String
	
	counter = 0
	
	Dim pos(10) As String
	
	For i = 1 To Len(dbstring)
		
		ch = Mid(ireverse(dbstring), i, 1)
		
		If ch = "\" Then
			
			counter = counter + 1
			
			pos(counter) = ireverse(Left(ireverse(dbstring), i - 1))
			
		End If
		
	Next i
	
	
	If InStr(dbstring, "\") > 0 Then
		
		JustFileName = Right(dbstring, InStr(ireverse(dbstring), "\") - 1)
		FilePath = Left(dbstring, Len(dbstring) - InStr(ireverse(dbstring), "\") + 1)
		
		If counter > 1 Then
			FileNameAndFolder = pos(2)
			ElseIf counter = 1 Then
			FileNameAndFolder = dbstring
		Else
			FileNameAndFolder = JustFileName
		End If
		
	Else
		
		JustFileName = dbstring
		
	End If
	
	JustFileNameNoExt = Mid(JustFileName, 1, InStr(JustFileName, ".") - 1)
	FileExtension = "." & Mid(dbstring, InStr(1, dbstring, ".") + 1, Len(dbstring) - InStr(1, dbstring, "."))
	
End Function











